library libfpserializer;

{$mode objfpc}{$H+}

uses
  fpjsonrtti,
  fpjson,
  SysUtils;

  function ObjectToJson(AObject: Pointer): PChar;
  {$IFDEF MSWINDOWS}export{$ELSE}cdecl{$ENDIF}; export;
  var
    s: TJSONStreamer;
    j: TJSONObject = nil;
  begin
    s := TJSONStreamer.Create(nil);
    try
      try
        if Assigned(AObject) then
        begin
          j := s.ObjectToJSON(TObject(AObject));
          Result := PChar(j.AsJSON + #0);
        end
        else
          Result := '{}' + #0;
      except
        Result := '{}' + #0;
        FreeAndNil(j);
        raise;
      end;
    finally
      FreeAndNil(j);
      s.Free;
    end;
  end;

exports
  ObjectToJson name 'ObjectToJson';

end.
